function [t2,d_est2,d_obs_corrected]=fit_g10(E_E0,N_N0,n,t,d_obs,err)

w1 = 2*pi ; % frequency annual
w2 = 2*pi/0.5 ; % frequency semi-annual
a(1:19)=1 ;


for iteration = 1:30

% Start model
  for i=1:n
     ylin(i,1)=   a(1) + a(2)*t(i)  ;          % linear term
     y_quad(i,1)= a(3)*t(i)^2     ;             % quadratic term
     y_cubic(i,1)= a(4)*t(i)^3    ;              % cubic term
     y_poly(i,1)= a(5)*t(i)^4 + a(6)*t(i)^5 + a(7)*t(i)^6 + a(8)*t(i)^7     ;       % poly 4, 5, 6 term
     y_anu(i,1)= a(18)*cos( t(i)*w1 + a(19)) + 0.5*a(18)*cos( t(i)*w2 + 2*a(19) + 0.5*pi) ;         % annual term
     yslope_lin(i,1) = a(9)*E_E0(i) + a(10)*N_N0(i) ; % lin slope
     yslope_quad(i,1)  = a(11)*E_E0(i)*E_E0(i) + a(12)*N_N0(i)*N_N0(i)+a(13)*E_E0(i)*N_N0(i) ; % quadratic slope
     yslope_cubic(i,1) = a(14)*E_E0(i)*E_E0(i)*E_E0(i) + a(15)*N_N0(i)*N_N0(i)*N_N0(i)+a(17)*E_E0(i)*E_E0(i)*N_N0(i) + a(16)*E_E0(i)*N_N0(i)*N_N0(i) ; % cubic slope
  end

  % decide model by merging above terms
   for i=1:n
     g0(i,1) = ylin(i,1) + y_quad(i,1) + y_cubic(i,1) + yslope_lin(i,1) + yslope_quad(i,1) + yslope_cubic(i,1) + y_anu(i,1) + y_poly(i,1)  ;    % linear term + slope
   end
   
 delta_d = d_obs - g0;

 m0 = a(1:19)' ;

 % Model matrix 'G' konstrueres.  
  for i=1:n
    dg_da1(i,1)=1;
    dg_da2(i,1)=t(i);
    dg_da3(i,1)=t(i)^2;
    dg_da4(i,1)=t(i)^3;
    dg_da5(i,1)=t(i)^4;
    dg_da6(i,1)=t(i)^5;
    dg_da7(i,1)=t(i)^6;
    dg_da8(i,1)=t(i)^7;
    
    dg_da9(i,1)= E_E0(i) ;
    dg_da10(i,1)= N_N0(i) ;

    dg_da11(i,1)= E_E0(i)*E_E0(i) ;
    dg_da12(i,1)= N_N0(i)*N_N0(i) ;
    dg_da13(i,1)= E_E0(i)*N_N0(i) ;

    dg_da14(i,1)= E_E0(i)*E_E0(i)*E_E0(i) ;
    dg_da15(i,1)= N_N0(i)*N_N0(i)*N_N0(i) ;
    dg_da17(i,1)= E_E0(i)*E_E0(i)*N_N0(i) ;
    dg_da16(i,1)= E_E0(i)*N_N0(i)*N_N0(i) ;

    dg_da18(i,1)=cos(t(i)*w1+a(19))+0.5*cos( t(i)*w2 + 2*a(19) + 0.5*pi);;
    dg_da19(i,1)=-a(18)*sin(t(i)*w1+a(19)) - 0.5*a(18)*sin(t(i)*w2 + 2*a(19) + 0.5*pi);
  end

% Bem?rk at  dgdm1 er s?jler med n elementer. G har s?ledes 4 s?jler (antal ubekendte) og n r?kker (antal observationer) 
%G=[ dg_da1 dg_da2 dg_da9 dg_da10 dg_da11 dg_da12 dg_da13 dg_da14 dg_da15 dg_da17 dg_da16 dg_da18 dg_da19 dg_da3 dg_da4 dg_da5 dg_da6 dg_da7 dg_da8] ;
 G=[ dg_da1 dg_da2 dg_da3 dg_da4 dg_da5 dg_da6 dg_da7 dg_da8 dg_da9 dg_da10 dg_da11 dg_da12 dg_da13 dg_da14 dg_da15 dg_da16 dg_da17 dg_da18 dg_da19] ;

C_obs = diag(err);
  
m_est=inv((G')*inv(C_obs)*G)*(G')*inv(C_obs)*delta_d ;

m = m0 + m_est ;

% m0 =[ a1 ; a2 ; a9; a10; a11; a12; a13; a18 ; a19 ; m5 ; m6 ];
a(1:19)=m(1:19) ;


end
% end iteration

H=inv((G')*G)*(G');
C_est=H*C_obs*H' ;

di=diag(C_est);

 for i=1:19
    std(i,1)=sqrt(di(i));
 end
 
 
% predicted elevation
 d_slope_lin = E_E0.*a(9) + N_N0.*a(10) ;                                                 % linear slope
 d_slope_quad = E_E0.*E_E0.*a(11) + N_N0.*a(12)+E_E0.*N_N0.*a(13); % quadratic slope
 d_slope_cubic= E_E0.*E_E0.*E_E0.*a(14) + N_N0.*N_N0.*N_N0.*a(15) + E_E0.*E_E0.*N_N0.*a(17) + E_E0.*N_N0.*N_N0.*a(16) ; % cubic slope
 d_lin =   a(1) + t.*a(2)   ; 
 d_quad= a(3)*t.^2       ;                                                              % quadratic term
 d_cubic= a(4)*t.^3       ;                                                             % cubic term
 d_poly = a(5)*t.^4 + a(6)*t.^5 +  a(7)*t.^6 +  a(8)*t.^7       ;                                                             % cubic term
 d_seasonal = a(18)*cos( t.*w1 + a(19)) + 0.5*a(18)*cos( t.*w2 + 2*a(19) + 0.5*pi)  ;


% output: observed elevations corrected for topo
d_obs_corrected=d_obs-d_slope_lin-d_slope_quad-d_slope_cubic;

%a19=a19-0.5;
t2=min(t)-0.0:(1/24):max(t)+0.0;
d_est2=a(1) + t2.*a(2) + a(3)*t2.^2 + a(4)*t2.^3 +  a(5)*t2.^4 + a(6)*t2.^5 +  a(7)*t2.^6 +  a(8)*t2.^7 + a(18)*cos( t2.*w1 + a(19)) + 0.5*a(18)*cos( t2.*w2 + 2*a(19) + 0.5*pi);

