clear

%% This Matlab scirpt covert netCFD file to geotiff file 

% input filename 
ncdisp('Greenland_DEM_1kmgrid.nc')

% read monthly elevation chages in eqvivalent ice. unit is m/month. 
% dhdt_vol has dimention, 1462 x 2520 x 247
X = ncread('Greenland_DEM_1kmgrid.nc','X') ;
Y = ncread('Greenland_DEM_1kmgrid.nc','Y') ;
height = ncread('Greenland_DEM_1kmgrid.nc','Height') ;
height=height';

height(isnan(height))=-1;

W = [1000 0 -621000; 0 1000 -3309000];
R7 = maprasterref(W,[2520 1462],"cells");

key.GTModelTypeGeoKey = 1;
key.GTRasterTypeGeoKey = 1;
key.ProjectedCSTypeGeoKey = 32767;
filename_geotiff='Greenland_DEM_1kmgrid.tif'

% select projection EPSG code
coordRefSysCode = 3413

geotiffwrite(filename_geotiff,height,R7,'GeoKeyDirectoryTag',key,CoordRefSysCode=coordRefSysCode)

figure
mapshow(filename_geotiff,'DisplayType','texturemap')
info = geotiffinfo('Greenland_DEM_1kmgrid.tif')
[A,R] = geotiffread('Greenland_DEM_1kmgrid.tif') ;
colorbar